SystemOrganization addCategory: #'TP2-Parte2'!
SystemOrganization addCategory: #'TP2-Parte2-Pruebas'!
SystemOrganization addCategory: #'TP2-Parte2-Test'!

Object subclass: #Perro
	instanceVariableNames: 'hambre vida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2'!

Perro class
	instanceVariableNames: 'hambre vida'!

Perro class
	instanceVariableNames: 'hambre vida'!

!Perro methodsFor: 'as yet unclassified' stamp: 'Tomas 5/6/2013 21:50'!
InicializarSuVida: cantidadVida suHambre: cantidadHambre
	self  vida: cantidadVida .
	self hambre: cantidadHambre .
	^self.! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Tomas 5/6/2013 21:40'!
caminar
	self hambre: (self hambre + 2).! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Tomas 5/6/2013 21:39'!
comer
	self hambre: (self hambre - 10).
	self vida: (self vida + 10).! !

!Perro methodsFor: 'as yet unclassified' stamp: 'Demian 4/27/2013 10:32'!
estaEnojado
	^ self hambre > 20! !

!Perro methodsFor: 'accessing' stamp: 'Demian 4/27/2013 10:31'!
hambre
	^ hambre! !

!Perro methodsFor: 'accessing' stamp: 'Tomas 5/6/2013 21:38'!
hambre: unaCantidad
	hambre := unaCantidad.! !

!Perro methodsFor: 'accessing' stamp: 'Tomas 5/4/2013 01:10'!
vida
	^ vida.! !

!Perro methodsFor: 'accessing' stamp: 'Tomas 5/4/2013 01:10'!
vida: unaCantidad
	vida := unaCantidad.! !

Object subclass: #RefactorEjemplo
	instanceVariableNames: 'metodosConPatron atributosConPatron'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2'!

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 23:55'!
agregar:unaNuevaClase En:unaClase

|nuevaclase atributosConSusMetodos metodosSinRepetir|
	nuevaclase := (Object  subclass: unaNuevaClase
					instanceVariableNames:''
					classVariableNames:''  
					poolDictionaries:'' 
					category: unaClase category).

	self atributosConPatron  do:[:a| nuevaclase addInstVarNamed: a]. "agrega atributos"

	unaClase addInstVarNamed: unaNuevaClase. "agraga la variable de la nueva clase"
	"unaClase methodDict do: [:m | nuevaclase compile:  m getSource]."
	self metodosConPatron do: [:m | nuevaclase compile:  (unaClase >> m ) sourceCode].		

	
"	atributosConSusMetodos :=self atributosConSusMetodosDe: unaClase.

	metodosSinRepetir := atributosConSusMetodos inject: Set new into: [:acum :a| acum union: a].

	metodosSinRepetir do:[:a| nuevaclase removeSelector: a]."! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 23:55'!
atributosConPatron

	^atributosConPatron.
! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 23:55'!
atributosConPatron:atributos

	atributosConPatron := atributos .
! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:45'!
atributosConSusMetodosDe: unaClase
	
	^ (unaClase instVarNames collect: [:m | unaClase whichSelectorsAccess: m]). ! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/14/2013 00:23'!
eliminarAtributosDe: unaClase

	self atributosConPatron do: [:a | unaClase removeInstVarNamed: a]. 
"#('velocidad' 'potencia' 'vision' ) do: [:a | unaClase removeInstVarNamed: a]. "
	

	
! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/14/2013 00:03'!
eliminarMetodosDe: unaClase

	self metodosConPatron  do: [:m | unaClase removeSelector: m].! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 23:58'!
esProblematica: unaClase

|atributosConSusMetodos atributosConSusMetodosSinRepetir|

	metodosConPatron := Set new.
	atributosConPatron := Set new.

	atributosConSusMetodos := self atributosConSusMetodosDe: unaClase.       "Selecciono los metodos que tienen atributos"

	self metodosConPatron: (self obtenerMetodosConPatronDe: atributosConSusMetodos) .

	atributosConSusMetodosSinRepetir:= self metodosConPatron inject: Set new into:[:acum :m| acum union: m].
	
	self atributosConPatron: (self obtenerAtributosConPatronDe: unaClase) .

	^ (metodosConPatron size = unaClase methodDictionary size) not. "Si la cantidad de metodos es igual a la de los metodos de la claase entonces estan todos conectados y no hay incomexos"
! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 23:53'!
metodosConPatron

	^metodosConPatron.! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 23:54'!
metodosConPatron:metodos

	metodosConPatron := metodos.! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 23:58'!
obtenerAtributosConPatronDe: unaClase 

^ ((unaClase instVarNames) select:[:a| self metodosConPatron anySatisfy:[:m| (unaClase whichSelectorsAccess: a) includes:m]]).! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/8/2013 23:29'!
obtenerMetodosConPatronDe: atributosMetodos
	|met|
	
	met := atributosMetodos inject: (atributosMetodos first:1)
					into: [:acum :metodos | (metodos anySatisfy: [:m | acum includes: m])
							ifTrue:[ acum union: metodos] 
							ifFalse: [acum] ].
						
	^  met inject: Set new into:[:acum :m| acum union: m].! !

!RefactorEjemplo methodsFor: 'as yet unclassified' stamp: 'Tomas 5/13/2013 21:10'!
refactorizar: unaClase Como: nombreClase 
	(self esProblematica:  unaClase)
		ifTrue:[self 	agregar:nombreClase  En: unaClase;
				eliminarAtributosDe:  unaClase;	                
			 	eliminarMetodosDe:  unaClase ].! !

Object subclass: #TheBlobPruebas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2-Pruebas'!

TestCase subclass: #TestTP2Parte2
	instanceVariableNames: 'refactor unaClase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte2-Test'!

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/14/2013 00:10'!
setUp

	unaClase := (Object subclass: #SuperCanino  
					instanceVariableNames:'velocidad potencia mordida salto vision'
					classVariableNames:'' 
					poolDictionaries: '' 
					category: 'TP2-Parte2-Pruebas').

	unaClase compile:'poderMortal
                                      ^velocidad+mordida+potencia'.

	unaClase compile:'poderMedio
                                      ^velocidad+potencia'.

	unaClase compile: 'PoderFeo
                                       ^vision+salto'.

	unaClase compile: 'PoderVision
                                       ^vision+salto + vision'.

	refactor := RefactorEjemplo  new.! !

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 01:44'!
tearDown 
	MetaUtil recreateCategory: 'TP2-Parte2-Pruebas'.! !

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 02:09'!
testEsNoProblematico
	"Testea si una Clase No es Problematica"
	|clase |
		clase := (Object subclass: #SuperCanino2
					instanceVariableNames:'velocidad potencia mordida'
					classVariableNames:'' 
					poolDictionaries:''  
					category: 'TP2-Parte2-Pruebas').

	clase compile:'poderMortal
                                      ^velocidad+mordida+potencia'.

	clase compile:'poderMedio
                                      ^velocidad+potencia'.

refactor  := RefactorEjemplo new .
	self assert: ((refactor esProblematica: clase) not ).! !

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/9/2013 00:46'!
testEsProblematico
	"Testea si una Clase es Problematica"

	self assert: (refactor esProblematica: unaClase).! !

!TestTP2Parte2 methodsFor: 'as yet unclassified' stamp: 'Tomas 5/14/2013 00:33'!
testRefactor
|cantidadAtributosAntesRefactor cantidadAtributosDespuesRefactor|

	cantidadAtributosAntesRefactor := unaClase instVarNames size.

	refactor refactorizar:  unaClase Como: #CaninoGemelo.

	cantidadAtributosDespuesRefactor := unaClase instVarNames size.
	
	self assert: ( cantidadAtributosAntesRefactor > cantidadAtributosDespuesRefactor ).! !
